databaseChangeLog:
  - changeSet:
      id: 1.0.0_initiate-tag
      author: firman_hanafi
      changes:
        - tagDatabase:
            tag: 1.0.0
  - changeSet:
      id: 1.0.0_01-create-user-table
      author: firman_hanafi
      changes:
        - createTable:
            tableName: users
            remarks: The users table for record of user data
            columns:
              - column:
                  name: id
                  type: varchar(100)
                  remarks: The id of user
                  constraints:
                    primaryKey: true
                    nullable: false
              - column:
                  name: code
                  type: varchar(200)
                  remarks: The code of user
                  constraints:
                    unique: true
                    nullable: false
              - column:
                  name: name
                  type: varchar(200)
                  remarks: The name of user
                  constraints:
                    nullable: false
              - column:
                  name: email
                  type: varchar(200)
                  remarks: The email of user
                  constraints:
                    nullable: false
              - column:
                  name: address
                  type: varchar(200)
                  remarks: The address of user
                  constraints:
                    nullable: false
              - column:
                  name: salary
                  type: numeric(20,2)
                  remarks: The salary of user
                  constraints:
                    nullable: false
              - column:
                  name: created_date
                  type: timestamp with timezone
                  remarks: The created date of record
                  constraints:
                    nullable: false
              - column:
                  name: last_modified_date
                  type: timestamp with timezone
                  remarks: The updated date of record
                  constraints:
                    nullable: true
              - column:
                  name: created_by
                  type: varchar(100)
                  remarks: To find out who created the record
                  constraints:
                    nullable: false
              - column:
                  name: last_modified_by
                  type: varchar(100)
                  remarks: To find out who updated the record
                  constraints:
                    nullable: true
      rollback:
        - dropTable:
            tableName: users
  - changeSet:
      id: 1.0.0_02-create-product-table
      author: firman_hanafi
      changes:
        - createTable:
            tableName: product
            remarks: The product table for record of user data
            columns:
              - column:
                  name: id
                  type: varchar(100)
                  remarks: The id of product
                  constraints:
                    primaryKey: true
                    nullable: false
              - column:
                  name: code
                  type: varchar(200)
                  remarks: The code of product
                  constraints:
                    nullable: false
              - column:
                  name: name
                  type: varchar(200)
                  remarks: The name of product
                  constraints:
                    nullable: false
              - column:
                  name: base_price
                  type: numeric(20,2)
                  remarks: The base price of product
                  constraints:
                    nullable: false
              - column:
                  name: selling_price
                  type: numeric(20,2)
                  remarks: The selling price of product
                  constraints:
                    nullable: false
              - column:
                  name: created_date
                  type: timestamp with timezone
                  remarks: The created date of record
                  constraints:
                    nullable: false
              - column:
                  name: last_modified_date
                  type: timestamp with timezone
                  remarks: The updated date of record
                  constraints:
                    nullable: true
              - column:
                  name: created_by
                  type: varchar(100)
                  remarks: To find out who created the record
                  constraints:
                    nullable: false
              - column:
                  name: last_modified_by
                  type: varchar(100)
                  remarks: To find out who updated the record
                  constraints:
                    nullable: true
      rollback:
        - dropTable:
            tableName: product
  - changeSet:
      id: 1.0.0_03-add-data-master
      author: firman_hanafi
      dbms: '!h2'
      comment: insert user and product data
      labels: local
      changes:
        - sqlFile:
            encoding: utf-8
            splitStatements: false
            path: /db/query/data/user/1.0.0_03-add-data-master_user-data.sql
            stripComments: true
        - sqlFile:
            encoding: utf-8
            splitStatements: false
            path: /db/query/data/product/1.0.0_03-add-data-master_product-data.sql
            stripComments: true
      rollback:
        - sqlFile:
            encoding: utf-8
            splitStatements: false
            path: /db/query/data/product/1.0.0_03-add-data-master_product-data-rollback.sql
            stripComments: true
        - sqlFile:
            encoding: utf-8
            splitStatements: false
            path: /db/query/data/user/1.0.0_03-add-data-master_user-data-rollback.sql
            stripComments: true